#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		perlvers	%(perl -v | awk '/This/ {print $9}' | sed -e 's/v//' | cut -d'(' -f2 | cut -d')' -f1)
%define		perl_lib	%{_datadir}/perl5/core_perl
#-----------------------------------------------------------------------------
#Crud is configured as a git submodule
%global		crud_version	3.2.0
%global		ceb_version	1.0-zm
%global		rtspserver_vers	cd7fd49bec

%global		zmuid_final	apache
%global		zmgid_final	apache
%global		zmtargetdistro	fc

%global		_unitdir	%{_libdir}/systemd/system
%global		_tmpfilesdir	%{_libdir}/tmpfiles.d/
#-----------------------------------------------------------------------------
Name		:	zoneminder
Version		:	1.37.61
Release		:	17.2.0.rel%{?dist}
Summary		:	A camera monitoring and analysis tool

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2+
URL		:	https://github.com/ZoneMinder/zoneminder
		#	https://github.com/FriendsOfCake/crud/
		#	http://www.zoneminder.com/CakePHP-Enum-Behavior

Source0		:	%{name}-%{version}.tar.gz
Source1		:	crud-%{crud_version}.tar.gz
Source2		:	CakePHP-Enum-Behavior-%{ceb_version}.tar.gz
Source3		:	RtspServer-%{rtspserver_vers}.tar.gz
Source4		:	%{name}-ok_addon.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	cmake
Buildrequires	:	desktop-file-utils
BuildRequires	:	ffmpeg-devel
BuildRequires	:	gzip
BuildRequires	:	libjpeg-turbo-devel
BuildRequires	:	mariadb
BuildRequires	:	perl(Date::Manip)
BuildRequires	:	perl(DBD::mysql)
BuildRequires	:	perl(LWP::UserAgent)
BuildRequires	:	perl(Sys::Mmap)


#-----------------------------------------------------------------------------
%description
'%{name}' is a set of applications which is intended to provide a complete
solution allowing you to capture, analyze, record and monitor any cameras you
have attached to a Linux based machine. It is designed to run on kernels which
support the Video For Linux (V4L) interface and has been tested with cameras
attached to BTTV cards, various USB cameras and IP network cameras. It is
designed to support as many cameras as you can attach to your computer without
too much degradation of performance.

This is a meta package for backwards compatibility with the existing
'%{name}' user base.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
#nothing

#=============================================================================
%package		common
Summary		:	Common files for %{name}, not tied to a specific web server

#-----------------------------------------------------------------------------
Requires	:	%{name}			=  %{version}-%{release}

Requires	:	ffmpeg
Requires	:	perl
Requires	:	php
#-----------------------------------------------------------------------------
%description		common
'%{name}' is a set of applications which is intended to provide a complete
solution allowing you to capture, analyze, record and monitor any cameras you
have attached to a Linux based machine. It is designed to run on kernels which
support the Video For Linux (V4L) interface and has been tested with cameras
attached to BTTV cards, various USB cameras and IP network cameras. It is
designed to support as many cameras as you can attach to your computer without
too much degradation of performance.

This is a meta-package that exists solely to allow the existing user base to
seamlessly transition to sub-packages.


#-----------------------------------------------------------------------------
%files			common
%doc README.md 
%license COPYING

# We want these two folders to have "normal" read permission
# compared to the folder contents
%dir %{_sysconfdir}/zm
%dir %{_sysconfdir}/zm/conf.d

# Config folder contents contain sensitive info
# and should not be readable by normal users
%{_sysconfdir}/zm/conf.d/README

%config(noreplace) %{_sysconfdir}/logrotate.d/zoneminder

%{_unitdir}/zoneminder.service
%{_sysconfdir}/rc.d/init.d/%{name}

#{_bindir}/zma
%{_bindir}/zmaudit.pl
%{_bindir}/zmc
%{_bindir}/zmcontrol.pl
%{_bindir}/zmdc.pl
%{_bindir}/zmeventtool.pl
%{_bindir}/zmfilter.pl
%{_bindir}/zmpkg.pl
%{_bindir}/zmtrack.pl
%{_bindir}/zmtrigger.pl
%{_bindir}/zmu
%{_bindir}/zmupdate.pl
%{_bindir}/zmvideo.pl
%{_bindir}/zmwatch.pl
%{_bindir}/zmcamtool.pl
%{_bindir}/zmtelemetry.pl
%{_bindir}/zmx10.pl
%{_bindir}/zmonvif-probe.pl
%{_bindir}/zmonvif-trigger.pl
%{_bindir}/zmrecover.pl
%{_bindir}/zmstats.pl
%{_bindir}/zm_rtsp_server
%{_bindir}/zmsystemctl.pl

%{_libexecdir}/%{name}/cgi-bin/nph-zms
%{_libexecdir}/%{name}/cgi-bin/zms

%{_datadir}/%{name}/fonts/default.zmfnt
%{_datadir}/%{name}/www/*
%{_datadir}/%{name}/db/*.sql
%{_datadir}/%{name}/icons/*/icon.xpm
%{_datadir}/%{name}/MacVendors.json
%{_datadir}/applications/%{name}.desktop
%{_datadir}/polkit-1/actions/com.zoneminder.systemctl.policy
%{_datadir}/polkit-1/actions/com.zoneminder.arp-scan.policy
%{_datadir}/polkit-1/rules.d/com.zoneminder.arp-scan.rules

%{perl_lib}/ONVIF/*.pm
%{perl_lib}/ONVIF/Analytics/Attributes/*.pm
%{perl_lib}/ONVIF/Analytics/Elements/*.pm
%{perl_lib}/ONVIF/Analytics/Types/*.pm
%{perl_lib}/ONVIF/Analytics/Typemaps/*.pm
%{perl_lib}/ONVIF/Analytics/Interfaces/Analytics/*.pm
%{perl_lib}/ONVIF/Device/Attributes/*.pm
%{perl_lib}/ONVIF/Device/Elements/*.pm
%{perl_lib}/ONVIF/Device/Interfaces/Device/*.pm
%{perl_lib}/ONVIF/Device/Types/*.pm
%{perl_lib}/ONVIF/Device/Typemaps/*.pm
%{perl_lib}/ONVIF/Deserializer/*.pm
%{perl_lib}/ONVIF/Media/Attributes/*.pm
%{perl_lib}/ONVIF/Media/Elements/*.pm
%{perl_lib}/ONVIF/Media/Interfaces/Media/*.pm
%{perl_lib}/ONVIF/Media/Types/*.pm
%{perl_lib}/ONVIF/Media/Typemaps/*.pm
%{perl_lib}/ONVIF/PTZ/Attributes/*.pm
%{perl_lib}/ONVIF/PTZ/Elements/*.pm
%{perl_lib}/ONVIF/PTZ/Interfaces/PTZ/*.pm
%{perl_lib}/ONVIF/PTZ/PTZ.pm
%{perl_lib}/ONVIF/PTZ/Types/*.pm
%{perl_lib}/ONVIF/PTZ/Typemaps/*.pm
%{perl_lib}/ONVIF/Serializer/*.pm
%{perl_lib}/WSDiscovery/*.pm
%{perl_lib}/WSDiscovery10/Attributes/*.pm
%{perl_lib}/WSDiscovery10/Elements/*.pm
%{perl_lib}/WSDiscovery10/Interfaces/WSDiscovery/*.pm
%{perl_lib}/WSDiscovery10/Typemaps/*.pm
%{perl_lib}/WSDiscovery10/Types/*.pm
%{perl_lib}/WSDiscovery11/Attributes/*.pm
%{perl_lib}/WSDiscovery11/Elements/*.pm
%{perl_lib}/WSDiscovery11/Interfaces/WSDiscovery/*.pm
%{perl_lib}/WSDiscovery11/Typemaps/*.pm
%{perl_lib}/WSDiscovery11/Types/*.pm
%{perl_lib}/ZoneMinder.pm
%{perl_lib}/WSNotification/Attributes/*.pm
%{perl_lib}/WSNotification/Elements/*.pm
%{perl_lib}/WSNotification/Interfaces/WSBaseNotificationSender/*.pm
%{perl_lib}/WSNotification/Types/*.pm
%{perl_lib}/WSNotification/Typemaps/*.pm
%{perl_lib}/WSSecurity/*.pm
%{perl_lib}/ZoneMinder/*.pm
%{perl_lib}/ZoneMinder/Control/*.pm
%{perl_lib}/ZoneMinder/Memory/*.pm
%{perl_lib}/ZoneMinder/Trigger/Channel.pm
%{perl_lib}/ZoneMinder/Trigger/Channel/*.pm
%{perl_lib}/ZoneMinder/Trigger/Connection.pm
%{perl_lib}/ZoneMinder/Trigger/Connection/*.pm

%{_mandir}/man3/*.3.gz
%{_mandir}/man8/*.8.gz

#=============================================================================
%package		httpd
Summary		:	'%{name}' configuration for Apache web server

#-----------------------------------------------------------------------------
Requires	:	%{name}-common		=  %{version}-%{release}
Requires	:	httpd
Requires	:	php

#-----------------------------------------------------------------------------
%description		httpd
'%{name}' is a set of applications which is intended to provide a complete
solution allowing you to capture, analyze, record and monitor any cameras you
have attached to a Linux based machine. It is designed to run on kernels which
support the Video For Linux (V4L) interface and has been tested with cameras
attached to BTTV cards, various USB cameras and IP network cameras. It is
designed to support as many cameras as you can attach to your computer without
too much degradation of performance.

This sub-package contains configuration specific to Apache web server

#-----------------------------------------------------------------------------
%files			httpd
%config(noreplace) %attr(640,root,%{zmgid_final}) %{_sysconfdir}/zm/zm.conf
%config(noreplace) %attr(640,root,%{zmgid_final}) %{_sysconfdir}/zm/conf.d/0*.conf
%config(noreplace) %{_sysconfdir}/zm/www/zoneminder.httpd.conf
%ghost %{_sysconfdir}/zm/www/zoneminder.conf
%config(noreplace) %{_sysconfdir}/zm/www/com.zoneminder.systemctl.rules.httpd
%ghost %{_datadir}/polkit-1/rules.d/com.zoneminder.systemctl.rules

%{_unitdir}/zoneminder.service.d/zm-httpd.conf
%{_tmpfilesdir}/zoneminder.httpd.tmpfiles.conf

%dir %attr(755,%{zmuid_final},%{zmgid_final}) %{_sharedstatedir}/zoneminder
%dir %attr(755,%{zmuid_final},%{zmgid_final}) %{_sharedstatedir}/zoneminder/events
%dir %attr(755,%{zmuid_final},%{zmgid_final}) %{_sharedstatedir}/zoneminder/sock
%dir %attr(755,%{zmuid_final},%{zmgid_final}) %{_sharedstatedir}/zoneminder/swap
%dir %attr(755,%{zmuid_final},%{zmgid_final}) %{_sharedstatedir}/zoneminder/temp
%dir %attr(755,%{zmuid_final},%{zmgid_final}) %{_localstatedir}/cache/zoneminder
%dir %attr(755,%{zmuid_final},%{zmgid_final}) %{_localstatedir}/log/zoneminder
#=============================================================================
%package		nginx
Summary		:	'%{name}' configuration for Nginx web server

#-----------------------------------------------------------------------------
Requires	:	%{name}-common		=  %{version}-%{release}
Requires	:	nginx
Requires	:	php

#-----------------------------------------------------------------------------
%description		nginx
'%{name}' is a set of applications which is intended to provide a complete
solution allowing you to capture, analyze, record and monitor any cameras you
have attached to a Linux based machine. It is designed to run on kernels which
support the Video For Linux (V4L) interface and has been tested with cameras
attached to BTTV cards, various USB cameras and IP network cameras. It is
designed to support as many cameras as you can attach to your computer without
too much degradation of performance.

This sub-package contains support for ZoneMinder with the Nginx web server

#-----------------------------------------------------------------------------
%files			nginx
%config(noreplace) %attr(640,root,nginx) %{_sysconfdir}/zm/zm.conf
%config(noreplace) %attr(640,root,nginx) %{_sysconfdir}/zm/conf.d/*.conf
%ghost %attr(640,root,nginx) %{_sysconfdir}/zm/conf.d/zmcustom.conf
%config(noreplace) %{_sysconfdir}/zm/www/zoneminder.nginx.conf
%config(noreplace) %{_sysconfdir}/zm/www/redirect.nginx.conf
%ghost %{_sysconfdir}/zm/www/zoneminder.conf
%config(noreplace) %{_sysconfdir}/zm/www/com.zoneminder.systemctl.rules.nginx
%ghost %{_datadir}/polkit-1/rules.d/com.zoneminder.systemctl.rules

%config(noreplace) %{_sysconfdir}/php-fpm.d/zoneminder.php-fpm.conf

%{_unitdir}/zoneminder.service.d/zm-nginx.conf
%{_tmpfilesdir}/zoneminder.nginx.tmpfiles.conf
%dir %attr(755,nginx,nginx) %{_sharedstatedir}/zoneminder
%dir %attr(755,nginx,nginx) %{_sharedstatedir}/zoneminder/events
%dir %attr(755,nginx,nginx) %{_sharedstatedir}/zoneminder/sock
%dir %attr(755,nginx,nginx) %{_sharedstatedir}/zoneminder/swap
%dir %attr(755,nginx,nginx) %{_sharedstatedir}/zoneminder/temp
%dir %attr(755,nginx,nginx) %{_localstatedir}/cache/zoneminder
%dir %attr(755,nginx,nginx) %{_localstatedir}/log/zoneminder
#=============================================================================
%prep
#setup 
%autosetup -p 1 -a 1
%{__rm} -rf ./web/api/app/Plugin/Crud
%{__mv} -f crud-%{crud_version} ./web/api/app/Plugin/Crud

# The all powerful autosetup macro does not work after the second source tarball
tar zxf %{SOURCE2}
%{__rm} -rf ./web/api/app/Plugin/CakePHP-Enum-Behavior
%{__mv} -f 					\
	CakePHP-Enum-Behavior-%{ceb_version}	\
	./web/api/app/Plugin/CakePHP-Enum-Behavior

tar zxf %{SOURCE3}
%{__rm} -rf ./dep/RtspServer
%{__mv} RtspServer-%{rtspserver_vers} ./dep/RtspServer

# Change the following default values
#./utils/zmeditconfigdata.sh ZM_OPT_CAMBOZOLA yes
#./utils/zmeditconfigdata.sh ZM_OPT_CONTROL yes
#./utils/zmeditconfigdata.sh ZM_CHECK_FOR_UPDATES no
#./utils/zmeditconfigdata.sh ZM_DYN_SHOW_DONATE_REMINDER no
#./utils/zmeditconfigdata.sh ZM_OPT_FAST_DELETE no

tar xf %{SOURCE4}
#-----------------------------------------------------------------------------
#building application
%build

cmake							\
	-B _bld						\
	-G Ninja					\
	-S .						\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}		\
	-D CMAKE_INSTALL_FULL_LIBDIR=%{_libdir}		\
	-D ZM_PERL_MM_PARMS:STRING=INSTALLDIRS=perl	\
	-D ZM_WEB_USER="%{zmuid_final}"			\
	-D ZM_WEB_GROUP="%{zmgid_final}"		\
	-D ZM_TARGET_DISTRO="%{zmtargetdistro}"		\

cmake							\
	--build						\
	_bld						\
	--parallel %(/usr/bin/getconf _NPROCESSORS_ONLN)\


#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}					\
	cmake						\
	--install _bld					\

desktop-file-install 					\
	--dir %{buildroot}%{_datadir}/applications	\
	--delete-original				\
	--mode 544					\
    	_bld/misc/%{name}.desktop

# Remove unwanted files and folders
find %{buildroot} 					\
	\(						\
	  -name .htaccess -or 				\
	  -name .editorconfig -or			\
	  -name .packlist -or				\
	  -name .git -or				\
	  -name .gitignore -or				\
	  -name .gitattributes -or			\
	  -name .travis.yml				\
	\)						\
	-type f -delete > /dev/null 2>&1 || :

# Recursively change shebang in all relevant scripts
#and set execute permission
find %{buildroot}%{_datadir}/%{name}/www/api		\
	 \(						\
	   -name cake -or				\
	   -name cake.php				\
	 \)						\
	-type f 					\
	-exec 						\
	sed -i 						\
	  's:^#!/usr/bin/env bash$:#! %{_buildshell}:'	\
	  {} \; -exec %{__chmod} 755 {} \;

# Use the system cacert file rather then the one bundled with CakePHP
%{__rm} -f %{buildroot}%{_datadir}/%{name}/www/api/lib/Cake/Config/cacert.pem
%{__ln_s}						\
  ../../../../../../../..%{_sysconfdir}/pki/tls/certs/ca-bundle.crt	\
  %{buildroot}%{_datadir}/%{name}/www/api/lib/Cake/Config/cacert.pem

#installing zoneminder starting/stopping script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a 						\
	%{name}-ok_addon/%{name}.init			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/%{name}

desktop-file-install					\
	--dir %{buildroot}%{_datadir}/applications	\
	--delete-original				\
	--mode 644					\
	%{buildroot}%{_datadir}/applications/zoneminder.desktop

# Remove unwanted files and folders
%{__rm} -fr %{buildroot}/usr/include
%{__rm} -fr %{buildroot}/usr/cmake
#=============================================================================
%changelog
